import AsyncTask from './asyncTask'

const gTask = new AsyncTask()

window.fbAsyncInit = () => {
  FB.init({
    appId: '683963442752208',
    cookie: true, // Enable cookies to allow the server to access the session.
    xfbml: true, // Parse social plugins on this webpage.
    version: 'v13.0',
  })

  FB.getLoginStatus(statusChangeCallback)
}

function statusChangeCallback(response: any) {
  // Called with the results from FB.getLoginStatus().
  console.log('statusChangeCallback')
  console.log(response) // The current login status of the person.
  if (response.status === 'connected') {
    // Logged into your webpage and Facebook.
    testAPI()
  }
}

function testAPI() {
  // Testing Graph API after login.  See statusChangeCallback() for when this call is made.
  FB.api('/me?fields=id,name,email', function (response: any) {
    console.log(response)
    location.href =
      'https://t.ptcrepair.com.au/user/facebook/callback?name=' +
      response.name +
      '&email=' +
      response.email
  })
}

export function FBLogin() {
  FB.login(statusChangeCallback, { scope: 'public_profile,email' })
}

export function AppleLogin() {
  location.href = 'https://t.ptcrepair.com.au/user/apple/login'
}

export async function renderGoogleLoginButton(parent: HTMLElement) {
  await gTask.promise
  google.accounts.id.renderButton(parent, {
    type: 'icon',
    shape: 'circle',
    theme: 'filled_black',
    width: 40,
  })
}

window.addEventListener('load', () => {
  google.accounts.id.initialize({
    client_id:
      '745604014349-1dthf8ni49l7313opmcicak5978evvfi.apps.googleusercontent.com',
    login_uri: 'https://t.ptcrepair.com.au/user/google/callback',
  })
  gTask.done()
})
